clear

load('neuralNet');
load('models');

duration = 250;
sessionsPerBin = 250;

okAngleBins = 1:36;
X_test = {};
Y_test = [];
idx = 1;

for angleBin = 1:length(models) % 36
if find(angleBin == okAngleBins)
    for i = 1:sessionsPerBin
        for HDcell = 1:length(models(angleBin).HDcells) % 21
            % Change to chose random 
            if length(models(angleBin).HDcells(HDcell).modelParam) > 1
                params = randperm(length(models(angleBin).HDcells(HDcell).modelParam)-1,1)+1;     
            else 
                params = 1;
            end
            noise = 0.5*rand(1);
            m = models(angleBin).HDcells(HDcell).modelParam(params);
            spikeTimesModel = IzhikevichEgen(m.a, m.b, m.c, m.d, m.I+noise, duration);
            spikesModel = zeros(1,duration);
            spikesModel(spikeTimesModel) = 1;
            X_test{idx}(HDcell,:) = spikesModel;  
            Y_test(idx) = angleBin*10-10;
        end 
            idx = idx+1;
    end 
end
end
Y_test = categorical(Y_test);

% Remove wrongly classified HD cells
XTest = removeCells(X_test, [19 20]);
YTest = Y_test;

miniBatchSize = 32;

%Test
[acc] = testLSTM(XTest, YTest, net, miniBatchSize);