function [X, Y] = removeSessionsWithFewSpikes(X, Y, minSpikes)
to_remove = [];

% Find all session with less spikes than minSpikes
for session = 1:length(X)
    if length(find(X{session})) < minSpikes
        to_remove(end+1) = session;
    end
end

% Remove sessions
X(to_remove) = [];
Y(to_remove) = [];

end