function [X, Y] = removeSessionsWithXSpikes(X, Y, Xspikes)
to_remove = [];

% Find all session with the number of sessions equal Xspikes
for session = 1:length(X)
    if length(find(X{session})) == Xspikes
        to_remove(end+1) = session;
    end
end

% Remove sessions
X(to_remove) = [];
Y(to_remove) = [];

end