function [acc] = testLSTM(XTest, YTest, net, miniBatchSize)

YPred = classify(net,XTest, ...
    'MiniBatchSize',miniBatchSize, ...
    'SequenceLength','longest');

acc = mean(sum(YPred == YTest)./numel(YTest));
figure
confusionchart(YTest,YPred'); 

end